From 98544838c72ccb9c3008b767d64185b06736195f Mon Sep 17 00:00:00 2001
From: Merlijn Wajer <merlijn@wizzup.org>
Date: Tue, 3 Dec 2019 17:57:15 +0800
Subject: [PATCH] HACK: for parse_offset, honour sample_offset

---
 src/cd-paranoia.c | 17 ++++++++++++-----
 1 file changed, 12 insertions(+), 5 deletions(-)

diff --git a/src/cd-paranoia.c b/src/cd-paranoia.c
index f9128d1..6b0c648 100644
--- a/src/cd-paranoia.c
+++ b/src/cd-paranoia.c
@@ -116,7 +116,7 @@ bigendianp(void)
 }
 
 static long
-parse_offset(cdrom_drive_t *d, char *offset, int begin)
+parse_offset(cdrom_drive_t *d, char *offset, int begin, int sample_offset)
 {
   track_t i_track= CDIO_INVALID_TRACK;
   long hours   = -1;
@@ -225,6 +225,10 @@ parse_offset(cdrom_drive_t *d, char *offset, int begin)
 
   /* We don't want to outside of the track; if it's relative, that's OK... */
   if( i_track != CDIO_INVALID_TRACK ){
+    if (ret != 1) {
+        ret -= (int)round(sample_offset / 587);
+    }
+
     if (cdda_sector_gettrack(d,ret) != i_track) {
       report("Time/sector offset goes beyond end of specified track.");
       exit(1);
@@ -715,6 +719,7 @@ main(int argc,char *argv[])
   long int force_cdrom_speed    =  0;
   long int force_overread       =  0;
   long int sample_offset        =  0;
+  long int hack_sample_offset        =  0;
   long int test_flags           =  0;
   long int toc_offset           =  0;
   long int max_retries          = 20;
@@ -802,6 +807,7 @@ main(int argc,char *argv[])
       break;
     case 'O':
       get_int_arg(c, &sample_offset);
+      hack_sample_offset = sample_offset;
       break;
     case 'p':
       output_type=0;
@@ -1158,13 +1164,14 @@ main(int argc,char *argv[])
         span2++;
       }
 
-      i_first_lsn=parse_offset(d, span, -1);
+      i_first_lsn=parse_offset(d, span, -1, hack_sample_offset);
 
       if(i_first_lsn==-1)
-        i_last_lsn=parse_offset(d, span2, cdda_disc_firstsector(d));
+        i_last_lsn=parse_offset(d, span2, cdda_disc_firstsector(d), hack_sample_offset);
 
-      else
-        i_last_lsn=parse_offset(d, span2, i_first_lsn);
+      else {
+        i_last_lsn=parse_offset(d, span2, i_first_lsn, hack_sample_offset);
+      }
 
       if (i_first_lsn == -1) {
         if (i_last_lsn == -1) {
-- 
2.17.1
